<template>
    <div class="container">
        <div class="row">
            <div class="col-4">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5 class="m-0">{{ type == 'create' ? 'Create' : 'Update' }} Publisher</h5>
                    </div>
                    <div class="card-body">
                        <div class="form-floating mb-3">
                            <input type="text" v-on:keyup.enter="onEnter" v-model="publisher.name" class="form-control" id="floatingInput" placeholder="Publisher Name">
                            <label for="floatingInput">Publisher Name</label>
                        </div>
                        <div v-if="type == 'update'">
                            <button :disabled="processing" @click="updatePublisher" class="float-end btn btn-primary btn-login text-uppercase fw-bold" type="button">
                                {{ processing ? "Please wait" : (type == 'create' ? "Create" : "Update") }}
                            </button>
                            <button :disabled="processing" @click="backToCreate" class="float-end btn btn-secondary btn-login text-uppercase fw-bold me-2" type="button">
                                Cancel
                            </button>
                        </div>
                        <div v-else>
                            <button :disabled="processing" @click="createPublisher" class="float-end btn btn-primary btn-login text-uppercase fw-bold" type="button">
                                {{ processing ? "Please wait" : (type == 'create' ? "Create" : "Update") }}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-8">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5 class="m-0">Publisher List</h5>
                    </div>
                    <div class="card-body">
                        <div v-if="validationMessage" :class="'col-12 alert '+validationMessage.alert">
                            {{ validationMessage.message }}
                        </div>
                        <table class="table table-compact table-hover">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Publisher Name</th>
                                    <th class="text-center">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="(publisher, index) in getterListPublishers.data" :key="publisher.id">
                                    <td>{{ index + 1 }}</td>
                                    <td>{{ publisher.name }}</td>
                                    <td class="text-center">
                                        <a class="mx-2 btn btn-sm btn-danger" @click="deletePublisher(publisher.id)" href="#">Delete</a>
                                        <a class="mx-2 btn btn-sm btn-warning" @click="editPublisher(publisher)" href="#">Edit</a>
                                    </td>
                                </tr>
                            </tbody>
                        </table>

                        <pagination align="center" :data="getterListPublishers" @pagination-change-page="listPublishers"></pagination>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { Bootstrap5Pagination as pagination } from 'laravel-vue-pagination';
import { mapActions } from 'vuex';

export default {
    name: "publisher",
    components: {
        pagination
    },
    data(){
        return {
            publisher: {
                id: null,
                name: null
            },
            type: 'create',
            processing: false,
            currentPage: 1
        }
    },
    mounted(){
        this.$store.dispatch('publisher/list', this.currentPage)
    },
    computed: {
        getterListPublishers(){
            return this.$store.getters['publisher/publishers'];
        },
        validationMessage(){
            return this.$store.getters['publisher/validationMessage'];
        }
    },
    methods: {
        ...mapActions({
        }),
        backToCreate(){
            this.type = 'create'
            this.publisher.name = null
        },
        onEnter(){
           if(this.type == 'update'){
                this.updatePublisher()
           }else{
                this.createPublisher()
           }
        },
        async listPublishers(page = 1){
            this.$store.dispatch('publisher/list', page)
            this.$router.push({ query: { page: page } })
        },
        async createPublisher(){
            this.processing = true
            setTimeout(() => {
                this.$store.dispatch('publisher/create', this.publisher)
                .then((response) => {
                    this.$store.dispatch('publisher/list', this.currentPage)
                    this.publisher.name = null
                    this.processing = false
                })
                .catch((response) => {
                    this.processing = false
                })
            }, 1000)
        },
        async deletePublisher(id){
            if(confirm('Are you sure want to delete this item?')){
                this.$store.dispatch('publisher/delete', id)
                .then((response) => {
                    this.$store.dispatch('publisher/list', this.currentPage)
                })
            }
        },
        editPublisher(publisher){
            this.type = 'update'
            this.publisher.name = publisher.name
            this.publisher.id = publisher.id
        },
        async updatePublisher(){
            this.processing = true
            setTimeout(() => {
                this.$store.dispatch('publisher/update', this.publisher)
                .then((response) => {
                    this.$store.dispatch('publisher/list', this.currentPage)
                    this.publisher.name = null
                    this.publisher.id = null
                    this.processing = false
                    this.type = 'create'
                })
                .catch((response) => {
                    this.processing = false
                })
            }, 1000)
        }
    }
}
</script>
